<?php

/*

	 	    WWW L-System Explorer
      (c) 2006 Mr. Zdeeck <zdeeck@borg.cz> / Borg Solutions
	 <http://zdeeck.borg.cz/programming/wlse.html>

This code is presented under GNU GPL. See file COPYING for more info.

*/

include("turtle.php");

// Set up variables
$w=$_REQUEST["w"];
$h=$_REQUEST["h"];
$x=$_REQUEST["x"];
$y=$_REQUEST["y"];

$iter=$_REQUEST["iter"];
if ($iter+0>10)
    $iter=10;

$bgcol=$_REQUEST["bgcol"];
$pencol1=$_REQUEST["pencol1"];
$pencol2=$_REQUEST["pencol2"];
$dotcol=$_REQUEST["dotcol"];
$s_step=$_REQUEST["s_step"];
$s_angle=$_REQUEST["s_angle"];
$d_step=$_REQUEST["d_step"];
$d_angle=$_REQUEST["d_angle"];
$root=stripslashes($_REQUEST["root"]);
$rules=stripslashes($_REQUEST["rules"]);
$action=$_REQUEST["action"];
$countxy=$_REQUEST["countxy"];

$lang=$_REQUEST["lang"];
if (trim($lang)=="") {
    $lang="en";
}

// Include language file
include("lang/wlse_${lang}.php");

function Trans($string,$help=true)
{
    global $trans;
    global $lang;

    if ($help)
	echo "<a onClick=\"window.open('help.php?lang=$lang#$string','help','scrollbars=yes,toolbar=no,width=500,menubar=no,resizable=yes,directories=no');\" class='helphref'>";
	
    echo $trans[$string];
    
    if ($help)
	echo "</A>";
}

// Setup default LSE logo
if ($action!="draw") {
    $w=600;
    $h=180;
    $s_angle=90;
    $s_step=700;
    $d_step=90;
    $d_angle=0;
    $iter=4;
    $bgcol="fdefa1";
    $pencol1="ff0000";
    $pencol2="ff0000";
    $dotcol="ff0000";
    $root="_+F";
    $rules="F=[ ^X-X++_ <LL-LL> ^X_ <LL-L-L.L+L+LL> ^X_ <[LL]+ L[-LL] L[-LL]> ] ^XXXXXXXXXX_;
X=<ff>;
L=[F]^ff_;";
    
    $action="draw";
    $countxy=1;
}


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>

 <head>
  <meta http-equiv="content-type" content="text/html;charset=<?php Trans("charset",false); ?>">
  <title>WWW L-System Explorer</title>
  <link href="css/main.css" rel="stylesheet" type="text/css" media="all">
  <link rel="shortcut icon" href="img/wlse.ico">
  <META NAME="Author" CONTENT="Mr. Zdeeck">
  <META NAME="Description" content="WWW L-System Explorer">
  <META NAME="Generator" content="Handmade HTML">
  <META NAME="Keywords" content="Zdeeck, L-System, Lindenmayer, PHP">
  <script language="javascript" type="text/javascript" src="presets.js"></script>
<?php /* include("presets.js"); */ ?>
 </head>
<!--

WWW L-System Explorer

(c) 2006 Mr.Zdeeck / Borg Solutions	[http://zdeeck.borg.cz]

Presented under GPL License, for more info please visit
http://www.gnu.org/copyleft/gpl.html.

-->
<body>
<center>
<div class='main'>
<h1>
<a href="<?php echo $SCRIPT_NAME."?lang=en"; ?>"><img src="img/en.gif" align=left alt="EN" border=0></a>
<a href="<?php echo $SCRIPT_NAME."?lang=cz"; ?>"><img src="img/cz.gif" align=right alt="CZ" border=0></a>
WWW L-System Explorer</h1>

<form action="l-system.php" method=post id=dataform name=dataform>
<table class=form border=0>
<tr>
 <td class=valname><?php Trans("width"); ?>:</td><td><input name=w value="<?php echo $w; ?>" size=4 id=w></td>
 <td class=valname><?php Trans("x"); ?>:</td><td><input name=x value="<?php echo $x; ?>" size=4 id=x></td>
 <td class=valname><?php Trans("step"); ?>:</td><td width=100><input name=s_step value="<?php echo $s_step; ?>" size=5 class=mval id='s_step'> px</td>
 <td class=valname><?php Trans("bgcol"); ?>:</td><td><span class='hash'>#</span><input name=bgcol value="<?php echo $bgcol; ?>" class=color id='bgcol' onChange="ChangeColor('bgcol');">
 <span class=xcolor style='background: #<?php echo $bgcol; ?>' id='s_bgcol'>&nbsp;</span>
 </td>

</tr>
<tr>
 <td class=valname><?php Trans("height"); ?>:</td><td><input name=h value="<?php echo $h; ?>" size=4 id='h'></td>
 <td class=valname><?php Trans("y"); ?>:</td><td><input name=y value="<?php echo $y; ?>" size=4 id='y'></td>
 <td class=valname><?php Trans("angle"); ?>:</td><td><input name=s_angle value="<?php echo $s_angle; ?>" size=5 class=mval id='s_angle'> &deg;</td>
 <td class=valname><?php Trans("pencol1"); ?>:</td><td><span class='hash'>#</span><input name=pencol1 value="<?php echo $pencol1; ?>" class=color id='pencol1' onChange="ChangeColor('pencol1');">
  <span class=xcolor style='background: #<?php echo $pencol1; ?>' id='s_pencol1'>&nbsp;</span> 
 </td>
</tr>
<tr>
 <td class=valname><?php Trans("iter"); ?>:</td><td><input name=iter value="<?php echo $iter; ?>" size=4 id=iter></td>
 <td class=valname><?php Trans("countxy"); ?>:</td><td><input type=checkbox <?php if ($countxy) echo "checked"; ?> name=countxy id='countxy' value=1></td>
 <td class=valname><?php Trans("d_step"); ?>:</td><td><input name=d_step value="<?php echo $d_step; ?>" size=5 class=mval id='d_step'>% / it</td>
 <td class=valname><?php Trans("pencol2"); ?>:</td><td><span class='hash'>#</span><input name=pencol2 value="<?php echo $pencol2; ?>" class=color id='pencol2' onChange="ChangeColor('pencol2');">
 <span class=xcolor style='background: #<?php echo $pencol2; ?>' id='s_pencol2'>&nbsp;</span> 
 </td>
</tr>
<tr>
 <td class=valname><?php Trans("root"); ?>:</td><td colspan=3><input name=root value="<?php echo htmlspecialchars($root); ?>" size=32 id=root></td>
 <td class=valname><?php Trans("d_angle"); ?>:</td><td><input name=d_angle value="<?php echo $d_angle; ?>" size=5 class=mval id='d_angle'>% / it</td>
 <td class=valname><?php Trans("dotcol"); ?>:</td><td><span class='hash'>#</span><input name=dotcol value="<?php echo $dotcol; ?>" class=color id='dotcol' onChange="ChangeColor('dotcol');">
  <span class=xcolor style='background: #<?php echo $dotcol; ?>' id='s_dotcol'>&nbsp;</span> 
 </td>
</tr>
<tr>
 <td class=valname><?php Trans("rules"); ?>:</td>
 <td colspan=5 align=left width=400>
    <textarea name=rules rows=5 cols=50 id=rules style='width: 350px'><?php echo htmlspecialchars($rules); ?></textarea><br><br>
    <input type=submit name=butt value="<?php Trans("draw",false); ?>" class='submit'>
 </td>
 <td class=valname><?php Trans("presets"); ?>:</td>
 <td valign=top>
    <input type=button onClick='SetPreset(0); dataform.submit();' value='<?php Trans("tree",false); ?>' class=preset><br>
    <input type=button onClick='SetPreset(1); dataform.submit();' value='<?php Trans("dragon",false); ?>' class=preset><br>
    <input type=button onClick='SetPreset(2); dataform.submit();' value='<?php Trans("kochflake",false); ?>' class=preset><br>
    <input type=button onClick='SetPreset(3); dataform.submit();' value='<?php Trans("rtree",false); ?>' class=preset><br>
    <input type=button onClick='SetPreset(4); dataform.submit();' value='<?php Trans("blossom",false); ?>' class=preset><br>
    <input type=button onClick='SetPreset(5); dataform.submit();' value='<?php Trans("peanogosper",false); ?>' class=preset><br>
    <input type=button onClick='SetPreset(6); dataform.submit();' value='<?php Trans("penrose",false); ?>' class=preset><br>
 </td>
</tr>

<tr>
 <td colspan=6 align=center>
 </td>
</tr>
</table>
<input type=hidden name='action' value='draw'>
<input type=hidden name='lang' value='<?php echo $lang; ?>'>
</form>
<?php
flush();

if ($action=="draw") {
if ($countxy) { 
    // Initialize Turtle
    $turtle = new Turtle (0,0,0,0);

    // Convert variables
    $xd_step=(100-$d_step)/100;
    $xd_angle=(100-$d_angle)/100;
    $string=$root;

    // Prepare rule field
    $begstr=$root.$rules;

    for ($i=0; $i < strlen($begstr); $i++) {
	$char=substr($begstr,$i,1);
	$rule[$char]=$char;
    }

    // Parse rules
    $rlz=explode(";",$rules);
    while ($rlzx = each ($rlz)) {
	$rlzx2=explode("=",trim($rlzx["value"]));
	if (trim($rlzx2[0])!="") {
	    $rule[trim($rlzx2[0])]=trim($rlzx2[1]);
	}    
    }

    // Iterate rules
    if ($iter<0)
	$iter=0;

    for ($i=0; $i < $iter; $i++) {
	$newstring="";
	for ($j=0; $j < strlen($string); $j++)
	    $newstring.=$rule[substr($string,$j,1)];

	$string=$newstring;
    }

    // Make invisible move
    $string="^".str_replace("_","^",$string);

    $deep=0;
    for ( $i=0; $i < strlen($string); $i++) {
	$comm=substr($string,$i,1);

        // Iteration deepness check
	if ($deep>$iter)
	    $ci=$iter;
	else
	    $ci=$deep;

	if ($deep<0)
	    $deep=0;

        $step=pow($xd_step,$deep)*$s_step;
	$angle=pow($xd_angle,$deep)*$s_angle;

	switch ($comm) {
	    case "F":	// Forward
		$turtle->Move($step);
	    break;

	    case "B":	// Backward
		$turtle->Move(-$step);
	    break;

	    case "R":	// Random - count in as
	    case "f":	// Half Forward
		$turtle->Move($step/2);
	    break;

	    case "b":	// Half Backward
		$turtle->Move(-$step/2);
	    break;

	    case "+":	// Rotate Clockwise
		$turtle->Rotate($angle);
	    break;

	    case "-":	// Rotate Anticlockwise
		$turtle->Rotate(-$angle);
	    break;

	    case "/":	// Rotate Half Clockwise
		$turtle->Rotate($angle/2);
	    break;

	    case "\\":	// Rotate Half Anticlockwise
		$turtle->Rotate(-$angle/2);
	    break;

	    case "^":	// Pen up
		$turtle->PenUp();
	    break;

	    case "_":	// Pen down
		$turtle->PenDown();
	    break;

	    case "[":	// Push
		$turtle->Push();
	    break;

	    case "]":	// Pop
		$turtle->Pop();
	    break;
	
	    case "<":	// Subiter
		$deep++;
	    break;
	
	    case ">":	// End subiter
		$deep--;
	    break;
    
	}
    }

    $x=round(($turtle->xmin + $turtle->xmax)/2);
    $y=round(($turtle->ymin + $turtle->ymax)/2);
?>
<script language="javascript" type="text/javascript">
<!--
    document.getElementById('x').value=<?php echo round($x); ?>;
    document.getElementById('y').value=<?php echo round($y); ?>;
    document.getElementById('countxy').checked=false;
//-->
</script>
<?php
}

$xf=round($w/2-$x);
$yf=round($h/2-$y);

?>
    <br>
    <img src='<?php echo htmlspecialchars("l-system-i.php?w=$w&h=$h&x=$xf&y=$yf&iter=$iter&bgcol=$bgcol&pencol1=$pencol1&pencol2=$pencol2&dotcol=$dotcol&s_step=$s_step&s_angle=$s_angle&d_step=$d_step&d_angle=$d_angle&root=".urlencode($root)."&rules=".urlencode($rules)."&stamp=".time()); ?>' border=0 alt='WLSE Image Output'>
    <br>
<?php } ?>
<h2>&copy; 2006 Mr. Zdeeck, <a href='https://mr.zdeeck.cz'>http://mr.zdeeck.cz</a>, download: <a href='https://mr.zdeeck.cz/wlse/wlse-1.0.2.tgz'>v1.0.2a</a></h2>
</div>

</center>
</body>
</html>