
<h1>Nápověda</h1>
<p>
<b>WWW L-System Explorer</b> je, jak už název napovídá, webový interpret
L-Systémů napsaný v PHP. Software obsahuje univerzální třídu pro tzv.
želví grafiku a je zvěřejněn pod licencí <a href="http://www.gnugpl.cz/v2/" class="help" target="_blank">GPL</a>.
V případě, že provedete nějaký upgrade softwaru či jeho části použijete,
dejte mi, prosím, vědět, ať mám alespoň nějaký feedback.

</p>

<p>
Pro více informací o L-Systémech můžete navštívit například
<a href="http://mujweb.atlas.cz/www/fraktaly/lsys.html" class="help" target="_blank">tuto</a> stránku společně s
<a href="http://mujweb.atlas.cz/www/fraktaly/anim.html" class="help" target="_blank">animací</a>. Nezapomeňte,
že se jazyky L-Systémů liší, tudíž je nutné držet se notace, která je <a href="#rules" class="help">popsána
níže</a>.

</p>
<hr>
<a name="width"></a><h3>Šířka</h3>
<p>
Určuje šířku výsledného obrázku v pixelech.
</p><hr>
<a name="height"></a><h3>Výška</h3>
<p>
Určuje výšku výsledného obrázku v pixelech.
</p><hr>
<a name="x"></a><h3>X středu</h3>
<p>
Horizontální pozice středu obrazce v pixelech.
</p><hr>
<a name="y"></a><h3>Y středu</h3>
<p>
Vertikální pozice středu obrazce v pixelech.
</p><hr>
<a name="countxy"></a><h3>Vypočítat střed</h3>
<p>
V případě, že je zaškrtnuto, je obrazec počítán dvakrát,
přičemž v prvním průchodu se zjistí minima a maxima v
obou směrech, z nichž je pak odvozen pravděpodobný
střed obrazce. Tento se doplní do políček (viz výše) a je provedeno vlastní
vykreselení. Po něm je políčko odškrtnuto, protože počítání limitů skoro dvakrát
zpomaluje vlastní chod, přičemž střed se pro většinu obrazců nemění
až tak často.
</p><hr>
<a name="iter"></a><h3>Počet iterací</h3>
<p>
Počet iteračních průchodů. Při každém z nich jsou použita pravidla na pracovní řetězec.
</p><hr>

<a name="step"></a><h3>Krok</h3>
<p>
Základní počet pixelů, o které se želva posune při jednom kroku.
</p><hr>

<a name="angle"></a><h3>Úhel</h3>
<p>
Základní úhel ve stupních, o které se želva otočí při příkazu otočení.
</p><hr>

<a name="d_step"></a><h3>-&Delta; kroku</h3>
<p>
V případě, že jsou ve výrazu vnořené iterace (tj. příkazy <b>&lt;</b> nebo <b>&gt;</b>),
je základní krok zmenšen o počet procent, které jsou uvedeny v tomto políčku. S další
vnořenou iterací je krok opět zmenšen o další procenta, avšak z délky stávajícího (již
zmenšeného) kroku. Tímto lze docílit jednoduchých definic např. pro stromy a jiné biologické útvary.
</p><hr>

<a name="d_angle"></a><h3>-&Delta; úhlu</h3>
<p>
V případě, že jsou ve výrazu vnořené iterace (tj. příkazy <b>&lt;</b> nebo <b>&gt;</b>),
je základní úhel zmenšen o počet procent, které jsou uvedeny v tomto políčku. S další
vnořenou iterací je úhel opět zmenšen o další procenta, avšak jako základní se bere stávající, již
zmenšený, úhel.
</p><hr>

<a name="bgcol"></a><h3>Barva pozadí</h3>
<p>
Hexadecimální triplet RGB barvy pozadí (tj. <code>FFAA0</code> je oranžová, <code>00FF00</code> je zelená, atd.).
</p><hr>

<a name="pencol1"></a><h3>Barva pera</h3>
<p>
Hexadecimální triplet RGB prvotní barvy pera (tj. <code>FF000</code> je červená, <code>0000FF</code> je modrá, atd.).
</p><hr>

<a name="pencol2"></a><h3>Cílová barva</h3>
<p>
V případě, že jsou ve výrazu vnořené iterace (tj. příkazy <b>&lt;</b> nebo <b>&gt;</b>),
mění se při každém zanoření barva pera ze <a href="#pencol1" class="help">základní barvy</a> v tuto barvu pomocí
interpolace jednotlivých složek R,G,B.
</p><hr>

<a name="dotcol"></a><h3>Barva bodu</h3>
<p>
Hexadecimální triplet RGB barvy teček (tj. <code>FFFF0</code> je žlutá, <code>FF00FF</code> je fialová, atd.),
které se kreslí příkazy <b>.</b> a <b>*</b>.
</p><hr>

<a name="presets"></a><h3>Přednastavené</h3>
<p>
Některé přednastavené parametry. Pro více podobných můžete navštívit např. <a href="http://www.246.dk/lsystems.html" class="help" target="_blank">tuto</a> stránku.
</p><hr>

<a name="root"></a><h3>Kořen</h3>
<p>
Inicializační řetězec, se kterým začíná systém pracovat. Je důležité
nezapomenout na první znak "<b>_</b>", tedy položit želvu dolů, jinak
se nic nevykreslí (želva bude pořád zvednutá).
</p><hr>

<a name="rules"></a><h3>Pravidla</h3>
<p>
Zde se definují pravidla pro iterace. Každé pravidlo je ve tvaru
</p>

<center><code>X=&lt;řetězec&gt;;</code></center><Br>

<p>
Přičemž za <code>X</code> je možno dosadit pouze <b>jeden</b> znak, <code>&lt;řetězec&gt;</code> může být
libovolně dlouhý. Pravidla se oddělují středníkem "<code>;</code>", za posledním
pravidlem však již být středník nemusí.
Rezervované znaky (nesmí se tedy vyskytovat na levé straně derivací) jsou
tedy <b>rovnítko</b> (=) a <b>středník</b> (;). Níže je uveden výčet všech
znaků, které mají význam příkazu pro želvu, avšak mohou se vyskytovat 
na levé straně derivací:
</p>

<table>
<tr><td class="big">F</td><td>krok želvou dopředu</td>
<tr><td class="big">B</td><td>krok želvou dozadu</td>
<tr><td class="big">R</td><td>krok želvou dopředu o délce <i>randomize(0,základní_krok)</i></td>
<tr><td class="big">+</td><td>otočit po směru hodinových ručiček</td>
<tr><td class="big">-</td><td>otočit proti směru hodinových ručiček</td>
<tr><td class="big">f</td><td>půlkrok želvou dopředu</td>
<tr><td class="big">b</td><td>půlkrok želvou dozadu</td>
<tr><td class="big">/</td><td>otočit po směru hodinových ručiček o polovinu</td>
<tr><td class="big">\</td><td>otočit proti směru hodinových ručiček o polovinu</td>
<tr><td class="big">[</td><td>uloží pozici a otočení želvy na zásobník</td>
<tr><td class="big">]</td><td>nahraje pozici a otočení želvy ze zásobníku</td>
<tr><td class="big">^</td><td>zvednout želvu</td>
<tr><td class="big">_</td><td>položit želvu</td>
<tr><td class="big">&lt;</td><td>zanořit se o jednu iteraci</td>
<tr><td class="big">&gt;</td><td>vynořit se o jednu iteraci</td>
<tr><td class="big">.</td><td>malá tečka</td>
<tr><td class="big">*</td><td>velká tečka</td>
</table>

<p align=right>
<a href="http://validator.w3.org/check?uri=referer">
<img src="http://www.w3.org/Icons/valid-html401"
     alt="Valid HTML 4.01 Transitional" height="31" width="88" border=0></a>
</p>
