/*

	 	    WWW L-System Explorer
      (c) 2006 Mr. Zdeeck <zdeeck@borg.cz> / Borg Solutions
	 <http://zdeeck.borg.cz/programming/wlse.html>

This code is presented under GNU GPL. See file COPYING for more info.

*/

var w = new Array();
var h = new Array();
var s_step = new Array();
var s_angle = new Array();
var d_step = new Array();
var d_angle = new Array();
var iter = new Array();
var root = new Array();
var rules = new Array();

var bgcol = new Array();
var pencol1 = new Array();
var pencol2 = new Array();
var dotcol = new Array();


// Nice Tree
w[0]=400;
h[0]=400;
s_step[0]=50;
s_angle[0]=30;
d_step[0]=20;
d_angle[0]=20;
iter[0]=5;
root[0]='_FF*';
rules[0]='*=[/+F<*>B-F<*>B-F<*>B-F<*>B]';
bgcol[0]='fdefa1';
pencol1[0]='0000ff';
pencol2[0]='ff00ff';
dotcol[0]='ff0000';

// Dragon
w[1]=400;
h[1]=400;
s_step[1]=10;
s_angle[1]=120;
d_step[1]=0;
d_angle[1]=0;
iter[1]=6;
root[1]='_F';
rules[1]='F=F+<F>-F';
bgcol[1]='000000';
pencol1[1]='ff0000';
pencol2[1]='ffff00';
dotcol[1]='ff0000';

// Koch snowflake
w[2]=400;
h[2]=400;
s_step[2]=1;
s_angle[2]=60;
d_step[2]=0;
d_angle[2]=0;
iter[2]=5;
root[2]='_/-F++F++F';
rules[2]='F=F-<F++F>-F';
bgcol[2]='ccccFF';
pencol1[2]='0000FF';
pencol2[2]='00ffFF';
dotcol[2]='ff0000';

// Random Tree
w[3]=400;
h[3]=400;
s_step[3]=50;
s_angle[3]=50;
d_step[3]=20;
d_angle[3]=20;
iter[3]=5;
root[3]='_FF*';
rules[3]='*=[/+[R<*>]-[R<*>]-[R<*>]-[R<*>]]';
bgcol[3]='fdefa1';
pencol1[3]='a02020';
pencol2[3]='400000';
dotcol[3]='00ff00';

// Blossom
w[4]=400;
h[4]=400;
s_step[4]=50;
s_angle[4]=90;
d_step[4]=40;
d_angle[4]=30;
iter[4]=6;
root[4]='_/F<X>-F<X>-F<X>-F<X>';
rules[4]='X=[+F<X>-F<X>-F<X>-F]';
bgcol[4]='408040';
pencol1[4]='ffff00';
pencol2[4]='00ff00';
dotcol[4]='CC40CC';

// Peano-Gosper
w[5]=400;
h[5]=400;
s_step[5]=5;
s_angle[5]=60;
d_step[5]=0;
d_angle[5]=0;
iter[5]=4;
root[5]='_X';
rules[5]='X=X+YF++YF-FX--FXFX-YF+;\nY=-FX+>YFYF++YF+FX--<FX-Y';
bgcol[5]='ffffff';
pencol1[5]='ff0000';
pencol2[5]='0000ff';
dotcol[5]='ffff00';

// Penrose
w[6]=400;
h[6]=400;
s_step[6]=15;
s_angle[6]=36;
d_step[6]=0;
d_angle[6]=0;
iter[6]=5;
root[6]='_[Y]++[Y]++[Y]++[Y]++[Y]';
rules[6]='W=<YF++ZF----XF[-YF----WF]++>;\nX=+YF--ZF[---WF--XF]+;\nY=<-WF++XF[+++YF++ZF]->;\nZ=--YF++++WF[+ZF++++XF]--XF;\nF=;';
bgcol[6]='000088';
pencol1[6]='ffff00';
pencol2[6]='008888';
dotcol[6]='ff0000';


function SetPreset (index) {
    document.getElementById('w').value=w[index];
    document.getElementById('h').value=h[index];
    document.getElementById('s_step').value=s_step[index];
    document.getElementById('s_angle').value=s_angle[index];
    document.getElementById('d_step').value=d_step[index];
    document.getElementById('d_angle').value=d_angle[index];
    document.getElementById('iter').value=iter[index];
    document.getElementById('root').value=root[index];
    document.getElementById('rules').value=rules[index];

    document.getElementById('bgcol').value=bgcol[index];
    document.getElementById('pencol1').value=pencol1[index];
    document.getElementById('pencol2').value=pencol2[index];
    document.getElementById('dotcol').value=dotcol[index];
    document.getElementById('countxy').checked=true;
    
    ChangeColor('bgcol');
    ChangeColor('pencol1');
    ChangeColor('pencol2');
    ChangeColor('dotcol');
}

function ChangeColor(field)
{
      document.getElementById('s_'+field).style.background='#'+document.getElementById(field).value;
}
