<?php
/*

	 	    WWW L-System Explorer
      (c) 2006 Mr. Zdeeck <zdeeck@borg.cz> / Borg Solutions
	 <http://zdeeck.borg.cz/programming/wlse.html>

This code is presented under GNU GPL. See file COPYING for more info.

*/

class DummyTurtle {
    var $x=0;
    var $y=0;
    var $angle=0;
    var $pen=false;

    function DummyTurtle ($x,$y,$angle,$pen) {
	$this->x=$x;
	$this->y=$y;
	$this->angle=$angle;
	$this->pen=$pen;    
    }
}

class Turtle extends DummyTurtle {
    var $im;
    var $color;
    var $dotcolor;
    var $debug;
    var $stackvals=0;
    var $stack=array();
    var $xmax=0;
    var $xmin=0;
    var $ymax=0;
    var $ymin=0;

    function Turtle ($im,$x,$y,$debug=false) {
	$this->im=$im;
	$this->x=$x;
	$this->y=$y;
	$this->debug=$debug;
    }

    function PenDown () {
	$this->pen=true;    
    }

    function PenUp () {
	$this->pen=false;
    }

    function Move ($step) {
	$tx=sin(deg2rad($this->angle))*$step;
	$ty=-cos(deg2rad($this->angle))*$step;
	
	if ($this->debug) {
	    echo "Target X: ".$tx."<br>";
	    echo "Target Y: ".$ty."<br>";
	    echo "Color: ".$this->color."<br>";
	    echo "Line Command: imageline($this->im,$this->x,$this->y,$this->x+$tx,$this->y+$ty,$this->color)<BR>";
	}

	if ($this->pen) {
	    imageline($this->im,$this->x,$this->y,$this->x+$tx,$this->y+$ty,$this->color);
	}
	
	$this->x+=$tx;
	$this->y+=$ty;
	
	if ($this->x > $this->xmax)
	    $this->xmax=$this->x;

	if ($this->x < $this->xmin)
	    $this->xmin=$this->x;

	if ($this->y > $this->ymax)
	    $this->ymax=$this->y;

	if ($this->y < $this->ymin)
	    $this->ymin=$this->y;

    }

    function Rotate($angle) {
	$this->angle=($this->angle+$angle) % 360;
    }
    
    function Push() {
	$this->stack[$this->stackvals]=new DummyTurtle ($this->x,$this->y,$this->angle,$this->pen);
	$this->stackvals++;
    }

    function Pop() {
	if ($this->stackvals != 0) {
	    $this->stackvals--;
	    $this->x = $this->stack[$this->stackvals]->x;
	    $this->y = $this->stack[$this->stackvals]->y;
	    $this->angle = $this->stack[$this->stackvals]->angle;
	    $this->pen = $this->stack[$this->stackvals]->pen;
	}
    }
    
    function Dot() {
	imagefilledellipse ( $this->im, $this->x, $this->y, 3, 3, $this->dotcolor );
    }

    function BigDot() {
	imagefilledellipse ( $this->im, $this->x, $this->y, 5, 5, $this->dotcolor );
    }
}
?>